#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) smooth in vec2 _fin_fragTexCoord;

struct SFragmentInput
{
	vec2 fragTexCoord;
	bool IsFrontFace;
};

layout(location = 0) out vec4 _fout_outColor;

struct SFragmentOutput
{
	vec4 outColor;
};

 uniform sampler2D Texture;

layout( std140) uniform UMulAddInfo
{
	vec4 MulValue;
	vec4 AddValue;
} MulAddInfo;

void FragmentMain( in SFragmentInput  fInput,  out SFragmentOutput  fOutput  )
{



	vec2 uv = fInput.fragTexCoord;


	fOutput.outColor =  texture(Texture, uv) ;
	vec4 mulVal =  MulAddInfo.MulValue ;
	vec4 addVal =  MulAddInfo.AddValue ;

	fOutput.outColor.rgb = max(fOutput.outColor.rgb * mulVal.rgb + addVal.rgb, vec3(0, 0, 0));
}


void main()
{
	SFragmentInput fInput;
	SFragmentOutput fOutput;

	fInput.fragTexCoord = _fin_fragTexCoord;
	fInput.IsFrontFace = gl_FrontFacing;
	FragmentMain(fInput, fOutput);
	_fout_outColor = fOutput.outColor;
}
